fix `cleanup` function
[grml-debootstrap.git] / grml-debootstrap
1 #!/bin/bash
2 # Filename:      grml-debootstrap
3 # Purpose:       wrapper around debootstrap for installing plain Debian via Grml
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see https://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2+
7 ################################################################################
8 # shellcheck disable=SC2001,SC2181
9
10 # error_handler {{{
11 error_handler() {
12    last_exit_code="$?"
13    last_bash_command="$BASH_COMMAND"
14    echo "Unexpected non-zero exit code $last_exit_code in ${BASH_SOURCE[*]} at line ${BASH_LINENO[*]} detected!
15 last bash command: $last_bash_command"
16    ## Check if "bailout" function is available.
17    ## This is not the case in chroot-script.
18    if command -v bailout >/dev/null 2>&1; then
19       bailout 1
20    else
21       exit 1
22    fi
23 }
24
25 set -e
26 set -E
27 set -o pipefail
28 trap "error_handler" ERR
29 export -f "error_handler"
30 # }}}
31
32 # variables {{{
33 PN="$(basename "$0")"
34 if [[ -d "$(dirname "$(command -v "$0")")"/.git ]]; then
35   VERSION="$(git --git-dir "$(dirname "$(command -v "$0")")"/.git describe | sed 's|^v||')"
36 else
37   VERSION="$(dpkg-query --show --showformat='${Version}' "$PN")"
38 fi
39 VERSION="${VERSION:-unknown}"
40 MNTPOINT="/mnt/debootstrap.$$"
41
42 # defaults
43 [ -n "$CHROOT_SCRIPTS" ] || CHROOT_SCRIPTS='yes'
44 [ -n "$CONFFILES" ] || CONFFILES='/etc/debootstrap'
45 [ -n "$DEBCONF" ] || DEBCONF='yes'
46 [ -n "$DEBIAN_FRONTEND" ] || DEBIAN_FRONTEND='noninteractive'
47 [ -n "$DEBOOTSTRAP" ] || DEBOOTSTRAP='debootstrap'
48 [ -n "$DEFAULT_LANGUAGE" ] || DEFAULT_LANGUAGE='en_US:en'
49 [ -n "$DEFAULT_LOCALES" ] || DEFAULT_LOCALES='en_US.UTF-8'
50 [ -n "$DISK_IDENTIFIER" ] || DISK_IDENTIFIER='26ada0c0-1165-4098-884d-aafd2220c2c6'
51 [ -n "$EXTRAPACKAGES" ] || EXTRAPACKAGES='yes'
52 [ -n "$FALLBACK_MIRROR" ] || FALLBACK_MIRROR='http://deb.debian.org/debian'
53 [ -n "$FIXED_DISK_IDENTIFIERS" ] || FIXED_DISK_IDENTIFIERS="no"
54 [ -n "$FORCE" ] || FORCE=''
55 [ -n "$HOSTNAME" ] || HOSTNAME='grml'
56 [ -n "$INITRD" ] || INITRD='yes'
57 [ -n "$INITRD_GENERATOR" ] || INITRD_GENERATOR='initramfs-tools'
58 [ -n "$INITRD_GENERATOR_OPTS" ] || INITRD_GENERATOR_OPTS=''
59 [ -n "$INSTALL_NOTES" ] || INSTALL_NOTES='/etc/debootstrap/install_notes'
60 [ -n "$LOCALES" ] || LOCALES='yes'
61 [ -n "$MIRROR" ] || MIRROR="$FALLBACK_MIRROR"
62 [ -n "$MKFS" ] || MKFS='mkfs.ext4'
63 [ -n "$MKFS_OPTS" ] || MKFS_OPTS=''
64 [ -n "$PACKAGES" ] || PACKAGES='yes'
65 [ -n "$POST_SCRIPTS" ] || POST_SCRIPTS='yes'
66 [ -n "$PRE_SCRIPTS" ] || PRE_SCRIPTS='yes'
67 [ -n "$RECONFIGURE" ] || RECONFIGURE='console-data'
68 [ -n "$RELEASE" ] || RELEASE='bookworm'
69 [ -n "$RM_APTCACHE" ] || RM_APTCACHE='yes'
70 [ -n "$SCRIPTS" ] || SCRIPTS='no' # deprecated, replaced by POST_SCRIPTS
71 [ -n "$SECURE" ] || SECURE='yes'
72 [ -n "$TIMEZONE" ] || TIMEZONE='Europe/Vienna'
73 [ -n "$TUNE2FS" ] || TUNE2FS='tune2fs -c0 -i0'
74 [ -n "$UPGRADE_SYSTEM" ] || UPGRADE_SYSTEM='yes'
75 [ -n "$VMSIZE" ] || VMSIZE="2G"
76 [ -n "$GRUB_INSTALL" ] || GRUB_INSTALL='yes'
77
78 # inside the chroot system locales might not be available, so use minimum:
79 export LANG=C
80 export LC_ALL=C
81 export LANGUAGE=C
82
83 # make sure interactive mode is only executed when
84 # using an empty configuration file or option --interactive
85 INTERACTIVE=''
86 # }}}
87
88 # help text {{{
89 usage() {
90   echo "$PN - wrapper around debootstrap for installing Debian
91
92 Usage: $PN [options]
93
94 Bootstrap options:
95
96   -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
97   -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
98                          instead of fetching packages from a mirror.
99   -r, --release <name>   Release of new Debian system (default: bullseye).
100   -t, --target <target>  Target partition (/dev/...) or directory where the
101                          system should be installed to.
102   -p, --mntpoint <mnt>   Mountpoint used for mounting the target system,
103                          has no effect if -t is given and represents a directory.
104       --debopt <params>  Extra parameters passed to the debootstrap command.
105       --interactive      Use interactive mode (frontend).
106       --nodebootstrap    Skip debootstrap, only do configuration to the target.
107       --grub <device>    Target for grub installation. Usage example: /dev/sda
108       --efi <device>     Target for EFI installation. Usage example: /dev/sda1
109       --arch <arch>      Set target architecture, use for installing i386 on amd64.
110       --filesystem <fs>  Filesystem that should be used when target is a partition
111                          or Virtual Machine (see --vmfile).
112       --force            Do not prompt for user acknowledgement.
113
114 Options for Virtual Machine deployment:
115
116       --vm               Set up a Virtual Machine on an existing block device
117                          instead of plainly installing to a partition or
118                          directory. Needs to be combined with --target.
119                          Example: --vm --target /dev/mapper/your-vm-disk
120       --vmfile           Like --vm, but install into a regular file (created by
121                          'qemu-img create -f raw ...') instead.
122                          Example: --vmfile --target /mnt/sda1/qemu.img
123       --vmsize <size>    Use specified size for size of VM file (default: 2G).
124                          Syntax as supported by qemu-img, like: --vmsize 3G
125       --vmefi            Create an EFI boot partition for the VM.
126
127 Configuration options:
128
129   -c, --config <file>      Use specified configuration file, defaults to
130                              /etc/debootstrap/config
131   -d, --confdir <path>     Place of config files for debootstrap, defaults
132                              to /etc/debootstrap
133       --packages <file>    Install packages defined in specified list file
134                              instead of using /etc/debootstrap/packages.
135       --nopackages         Skip installation of packages defined in
136                              /etc/debootstrap/packages
137       --nokernel           Skip installation of default kernel images.
138       --nointerfaces       Do not copy /etc/network/interfaces from host system
139                            to target system.
140                            (This option is automatically enabled when using --vmfile.)
141       --defaultinterfaces  Install a default /etc/network/interfaces file (enabling
142                            DHCP for eth0) instead of taking over config from host system.
143       --debconf <file>     Pre-seed packages using specified pre-seed db file.
144       --grmlrepos          Enable Grml's Debian repository (deb.grml.org).
145       --backportrepos      Enable Debian's backports repository (backports.debian.org).
146       --keep_src_list      Do not overwrite user provided apt sources.list.
147       --contrib            Enable 'contrib' in COMPONENTS (defaults to 'main' only).
148       --non-free           Enable non-free / non-free-firmware in COMPONENTS (defaults to 'main' only).
149       --hostname <name>    Hostname of Debian system.
150       --nopassword         Do not prompt for the root password.
151       --password <pwd>     Use specified password as password for user root.
152       --sshcopyauth        Use ${HOME}/.ssh/authorized_keys to authorise root login on the target system.
153       --sshcopyid          Use locally available public keys to authorise root login on the target system.
154       --bootappend <line>  Add specified appendline to kernel whilst booting.
155       --chroot-scripts <d> Execute chroot scripts from specified directory.
156       --pre-scripts <dir>  Execute scripts from specified directory (before chroot-scripts).
157       --scripts <dir>      Execute scripts from specified directory (after chroot-scripts).
158       --remove-configs     Delete grml-debootstrap configuration files from installed system.
159
160 Other options:
161
162   -v, --verbose            Increase verbosity.
163       --debug              Execute in very verbose way.
164   -h, --help               Print this usage information and exit.
165   -V, --version            Show summary of options and exit.
166
167 Usage examples can be found in the grml-debootstrap manpage.
168 Send bugreports to the grml-team: bugs (at) grml.org || https://grml.org/bugs/
169 "
170 }
171
172 if [ "$1" = '-h' ] || [ "$1" = '-help' ] || [ "$1" = "--help" ] ; then
173    usage
174    echo 'Please notice that this script requires root permissions!'
175    exit 0
176 fi
177 # }}}
178
179 # early helper functions {{{
180 # skip colors when running within a dumb terminal
181 if [ "${TERM}" = "dumb" ] ; then
182   GOOD=
183   BAD=
184   WARN=
185   NORMAL=
186 else
187   GOOD='\e[32;01m'
188   BAD='\e[31;01m'
189   WARN='\e[33;01m'
190   NORMAL='\e[0m'
191 fi
192
193 einfo() {
194   einfon "$1\\n"
195   return 0
196 }
197
198 einfon() {
199   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
200   printf " %s*%s $*" "${GOOD}" "${NORMAL}"
201   LAST_E_CMD=einfon
202   return 0
203 }
204
205 ewarn() {
206   printf " %s*%s $*\\n" "${WARN}" "${NORMAL}"
207   return 0
208 }
209
210 eerror() {
211   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
212   printf " %s*%s $*\\n" "${BAD}" "${NORMAL}" >&2
213   LAST_E_CMD=eerror
214   return 0
215 }
216
217 eend() {
218   local retval="${1:-0}"
219   shift
220   if [ "$retval" -gt 0 ]; then
221     printf " %s-> Failed (rc=%s)%s\\n" "${BAD}" "${retval}" "${NORMAL}"
222   fi
223   return "$retval"
224 }
225
226 check4root(){
227   if [ "$(id -u 2>/dev/null)" != 0 ] ; then
228     echo 1>&2 "Error: please run this script with uid 0 (root)." ; return 1
229   fi
230 }
231
232 check4progs(){
233   local RC=''
234   for arg in "$@" ; do
235     command -v "$arg" >/dev/null 2>&1 || RC="$arg"
236   done
237   if [ -n "$RC" ] ; then
238      echo "$RC not installed"
239      return 1
240   fi
241 }
242 # }}}
243
244 # helper functions {{{
245 cleanup() {
246   if [ -n "$CHROOT_VARIABLES" ] ; then
247     einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
248   fi
249
250   if [ -n "$STAGES" ] ; then
251     einfo "Removing ${STAGES}" ; rmdir "$STAGES" ; eend $?
252   fi
253
254   if [ -n "$ARM_EFI_TARGET" ]; then
255     umount "${MNTPOINT}/boot/efi" >/dev/null 2>&1
256   fi
257
258   # Remove temporary mountpoint again
259   if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
260     if [ -d "$MNTPOINT" ] ; then
261       rmdir "$MNTPOINT" 2>/dev/null
262     fi
263   fi
264
265   # make sure $TARGET is not mounted when exiting grml-debootstrap
266   if [ -n "$MNTPOINT" ] ; then
267     if grep -q "$MNTPOINT" /proc/mounts ; then
268       # make sure nothing is left inside chroot so we can unmount it
269       for service in ssh mdadm ; do
270         if [ -x "${MNTPOINT}/etc/init.d/${service}" ] ; then
271           chroot "$MNTPOINT" "/etc/init.d/${service}" stop
272         fi
273       done
274
275       [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a >/dev/null 2>&1
276
277       # ugly, but make sure we really don't leave anything (/proc /proc and
278       # /dev /dev are intended, trying to work around timing issues, see #657023)
279       for ARG in /run/udev /sys /proc /proc /dev/pts /dev/pts /dev /dev ; do
280         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1
281         umount "$MNTPOINT"/$ARG >/dev/null 2>&1
282       done
283
284       if [ -n "$ISODIR" ] ; then
285         [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" >/dev/null 2>&1
286       fi
287
288       if [ -n "$DIRECTORY" ] ; then
289         einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice."
290       else
291         einfo "Unmounting $MNTPOINT"
292         umount "$MNTPOINT" || eend $?
293       fi
294
295       if [ -n "$STAGES" ] ; then
296         echo -n "Removing stages directory ${STAGES}: "
297         rm -rf "$STAGES" && echo 'done'
298       fi
299
300       # remove directory only if we used the default with process id inside the name
301       if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
302         einfo "Removing directory ${MNTPOINT}"
303         rmdir "$MNTPOINT" || eend $?
304       fi
305     fi
306   fi
307
308   if [ -n "${ORIG_TARGET}" ] ; then
309     einfo "Removing loopback mount of file ${ORIG_TARGET}."
310     kpartx -d "${ORIG_TARGET}" || eend $?
311     # Workaround for a bug in kpartx which doesn't clean up properly,
312     # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
313     if dmsetup ls | grep -q "^${LOOP_PART} "; then
314       kpartx -d "/dev/${LOOP_DISK}" >/dev/null || eend $?
315     fi
316   fi
317 }
318
319 # we want to exit smoothly and clean:
320 bailout(){
321   eend "$1" || true
322
323   cleanup
324
325   [ -n "$1" ] && EXIT="$1" || EXIT="1"
326   [ -n "$2" ] && einfo "Notice: remove $STAGES/$2 to reexecute the stage"
327
328   exit "$EXIT"
329 }
330 trap bailout HUP INT QUIT TERM
331
332 # we want to execute all the functions only once, simple check for it:
333 stage() {
334   if [ -n "$2" ] ; then
335      echo "$2" > "${STAGES}/${1}"
336      return 0
337   elif grep -q 'done' "${STAGES}/${1}" 2>/dev/null ; then
338      ewarn "Notice: stage $1 has been executed already, skipping execution therefore."
339      ewarn "  To reexecute it clean up the according directory inside $STAGES"
340      return 1
341   fi
342 }
343 # }}}
344
345 # source main configuration file {{{
346 if [ -r /etc/debootstrap/config ] ; then
347   # shellcheck disable=SC1091
348   . /etc/debootstrap/config
349 fi
350 # }}}
351
352 # cmdline handling {{{
353 CMDLINE_OPTS=mirror:,iso:,release:,target:,mntpoint:,debopt:,defaultinterfaces,interactive,nodebootstrap,nointerfaces,nokernel,nopackages,filesystem:,config:,confdir:,packages:,chroot-scripts:,scripts:,post-scripts:,pre-scripts:,debconf:,vm,vmfile,vmsize:,vmefi,keep_src_list,hostname:,password:,nopassword,grmlrepos,backportrepos,bootappend:,grub:,efi:,arch:,insecure,verbose,help,version,force,debug,contrib,non-free,remove-configs,sshcopyid,sshcopyauth
354
355 _opt_temp=$(getopt --name grml-debootstrap -o +m:i:r:t:p:c:d:vhV --long \
356   $CMDLINE_OPTS -- "$@")
357
358 if [ $? != 0 ]; then
359   eerror "Try 'grml-debootstrap --help' for more information."; eend 1; exit 1
360 fi
361 eval set -- "$_opt_temp"
362
363 while :; do
364   case "$1" in
365
366   # == Bootstrap options
367   --mirror|-m)         # Mirror which should be used for apt-get/aptitude
368     shift; _opt_mirror="$1"
369     ;;
370   --iso|-i)            # Mountpoint where a Debian ISO is mounted to
371     shift; _opt_iso="$1"
372     ;;
373   --release|-r)        # Release of new Debian system
374     shift; _opt_release="$1"
375     ;;
376   --target|-t)         # Target partition (/dev/...) or directory
377     shift; _opt_target="$1"
378     ;;
379   --vm)                # Virtual machine image (no file)
380     _opt_vm="T"
381     ;;
382   --vmfile)            # Virtual machine file
383     _opt_vmfile="T"
384     ;;
385   --vmsize)            # size of Virtual machine file
386     shift; _opt_vmsize="$1"
387     ;;
388   --vmefi)            # Create an EFI boot partition for the VM
389     _opt_vmefi="T"
390     ;;
391   --mntpoint|-p)       # Mountpoint used for mounting the target system
392     shift; _opt_mntpoint="$1"
393     ;;
394   --debopt)            # Extra parameters passed to the debootstrap command
395     shift; _opt_debopt="$1"
396     ;;
397   --filesystem)        # Filesystem that should be used
398     shift; _opt_filesystem="$1" ; FILESYSTEM="${_opt_filesystem}"
399     ;;
400   --interactive)       # Use interactive mode (frontend)
401     _opt_interactive=T
402     ;;
403   --nodebootstrap)     # Skip debootstrap, only do configuration to the target
404     _opt_nodebootstrap=T
405     ;;
406   --nopackages)        # Skip installation of packages defined in /etc/debootstrap/packages
407     _opt_nopackages=T
408     ;;
409   --arch)              # Target architecutre
410     shift; _opt_arch="$1"
411     ;;
412   # just for backwards compatibility
413   --insecure)
414     _opt_insecure=T
415     ;;
416   #
417
418   # == Configuration options
419   --config|-c)         # Use specified configuration file, defaults to /etc/debootstrap
420     shift; _opt_config="$1"
421     ;;
422   --confdir|-d)        # Place of config files for debootstrap, defaults to /etc/debootstrap
423     shift; _opt_confdir="$1"
424     ;;
425   --packages)          # Install packages defined in specified file
426     shift; _opt_packages="$1"
427     _opt_packages_set=T
428     ;;
429   --debconf)           # Pre-seed packages using specified file
430     shift; _opt_debconf="$1"
431     _opt_debconf_set=T
432     ;;
433   --pre-scripts)       # Execute scripts from specified directory (before chroot-scripts).
434     shift; _opt_pre_scripts="$1"
435     _opt_pre_scripts_set=T
436     ;;
437   --scripts)           # Execute scripts from specified directory [NOTE: deprecated, replaced via --post-scripts]
438     shift; _opt_scripts="$1"
439     _opt_scripts_set=T
440     ;;
441   --post-scripts)       # Execute scripts from specified directory
442     shift; _opt_post_scripts="$1"
443     _opt_post_scripts_set=T
444     ;;
445   --chroot-scripts)   # Execute chroot scripts from specified directory
446     shift; _opt_chroot_scripts="$1"
447     _opt_chroot_scripts_set=T
448     ;;
449   --keep_src_list)     # Do not overwrite user provided apt sources.list
450     _opt_keep_src_list=T
451     ;;
452   --hostname)          # Hostname of Debian system
453     shift; _opt_hostname="$1"
454     ;;
455   --password)          # Use specified password as password for user root
456     shift; _opt_password="$1"
457     ;;
458   --defaultinterfaces) # Install default /etc/network/interfaces
459     _opt_defaultinterfaces=T
460     ;;
461   --nointerfaces)      # Skip installation of /etc/network/interfaces
462     _opt_nointerfaces=T
463     ;;
464   --nokernel)          # Skip installation of default kernel images
465     _opt_nokernel=T
466     ;;
467   --nopassword)        # Skip password dialog
468     _opt_nopassword=T
469     ;;
470   --sshcopyid)         # Use locally available public keys to authorise root login on the target system
471     _opt_sshcopyid=T
472     ;;
473   --sshcopyauth)       # Use .ssh/authorized_keys to authorise root login on the target system
474     _opt_sshcopyauth=T
475     ;;
476   --grmlrepos)         # Enable Grml repository
477     _opt_grmlrepos=T
478     ;;
479   --backportrepos)     # Enable Debian backports repository
480     _opt_backportrepos=T
481     ;;
482   --bootappend)        # Add specified appendline to kernel whilst booting
483     shift; _opt_bootappend="$1"
484     ;;
485   --grub)              # Target for grub installation. Use grub syntax for specifying
486     shift; _opt_grub="$1"
487     ;;
488   --efi)               # Target for EFI boot installation
489     shift; _opt_efi="$1"
490     ;;
491   --contrib)           # Add 'contrib' to list of components
492     _opt_contrib=T
493     ;;
494   --non-free)          # Add 'non-free' to list of components
495     _opt_non_free=T
496     ;;
497   --remove-configs)    # Drop config files from installed system
498     _opt_remove_configs=T
499     ;;
500
501   # == Other options
502   --verbose|-v)        # Increase verbosity
503     if [ "$_opt_verbose" ]; then
504       _opt_verbose=$( _opt_verbose + 1 )
505     else
506       _opt_verbose=1
507     fi
508     ;;
509   --debug)             # Execute in debug mode
510     _opt_debug=T
511     ;;
512   --help|-h)           # Print usage information and exit
513     _opt_help=T
514     ;;
515   --version|-V)        # Show version information and exit
516     _opt_version=T
517     ;;
518   --force)             # Do not prompt for user input
519     _opt_force=T
520     ;;
521   --)
522     shift; break
523     ;;
524   *)
525     eerror "Internal getopt error!"; eend 1 ; exit 1
526     ;;
527   esac
528   shift
529 done
530
531 # == business-logic of command line parameter-processing
532
533 # source configuration file in <confdir> if supplied. {{{
534 [ "$_opt_confdir" ] && {
535   CONFFILES=$_opt_confdir
536   einfo "Using config files under $CONFFILES/."
537   if ! [ -r "$CONFFILES/config" ] ; then
538     eerror "Error: config file $CONFFILES/config not found."; bailout 1
539   fi
540   # shellcheck disable=SC1091 source=config
541   if ! . "$CONFFILES/config" ; then
542     eerror "Error reading config file $CONFFILES/config" ; bailout 1
543   fi
544   # restore the command line parameter value
545   CONFFILES=$_opt_confdir
546 }
547 # }}}
548
549 [ "$_opt_mirror" ]              && MIRROR=$_opt_mirror
550 [ "$_opt_iso" ]                 && ISO=$_opt_iso
551 [ "$_opt_release" ]             && RELEASE=$_opt_release
552 [ "$_opt_target" ]              && TARGET=$_opt_target
553 [ "$_opt_vm" ]                  && VIRTUAL=1
554 [ "$_opt_vmfile" ]              && VMFILE=1 && VIRTUAL=1
555 [ "$_opt_vmsize" ]              && VMSIZE=$_opt_vmsize
556 [ "$_opt_vmefi" ]               && VMEFI=1
557 [ "$_opt_mntpoint" ]            && MNTPOINT=$_opt_mntpoint
558 [ "$_opt_debopt" ]              && DEBOOTSTRAP_OPT=$_opt_debopt
559 [ "$_opt_interactive" ]         && INTERACTIVE=1
560 [ "$_opt_config" ]              && CONFIGFILE=$_opt_config
561 [ "$_opt_filesystem" ]          && MKFS="mkfs.$_opt_filesystem"
562 [ "$_opt_packages_set" ]        && PACKAGES='yes'
563 [ "$_opt_nopackages" ]          && PACKAGES=''
564 [ "$_opt_debconf_set" ]         && DEBCONF='yes'
565 [ "$_opt_post_scripts_set" ]    && POST_SCRIPTS='yes'
566 [ "$_opt_pre_scripts_set" ]     && PRE_SCRIPTS='yes'
567 [ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
568 [ "$_opt_keep_src_list" ]       && KEEP_SRC_LIST='yes'
569 [ "$_opt_grmlrepos" ]           && GRMLREPOS='yes'
570 [ "$_opt_backportrepos" ]       && BACKPORTREPOS='yes'
571 [ "$_opt_hostname" ]            && HOSTNAME=$_opt_hostname
572 [ "$_opt_password" ]            && ROOTPASSWORD=$_opt_password
573 [ "$_opt_nopassword" ]          && NOPASSWORD='yes'
574 [ "$_opt_defaultinterfaces" ]   && USE_DEFAULT_INTERFACES="true"
575 [ "$_opt_nointerfaces" ]        && NOINTERFACES="true"
576 [ "$_opt_nokernel" ]            && NOKERNEL="true"
577 [ "$_opt_sshcopyid" ]           && SSHCOPYID="true"
578 [ "$_opt_sshcopyauth" ]         && SSHCOPYAUTH="true"
579 [ "$_opt_bootappend" ]          && BOOT_APPEND=$_opt_bootappend
580 [ "$_opt_grub" ]                && GRUB=$_opt_grub
581 [ "$_opt_efi" ]                 && EFI=$_opt_efi
582 [ "$_opt_arch" ]                && ARCH=$_opt_arch
583 [ "$_opt_insecure" ]            && echo "Warning: --insecure is deprecated, continuing anyway."
584 [ "$_opt_force" ]               && FORCE=$_opt_force
585 [ "$_opt_verbose" ]             && VERBOSE="-v"
586 [ "$_opt_debug" ]               && DEBUG="true"
587 [ "$_opt_remove_configs" ]      && REMOVE_CONFIGS="yes"
588
589 # make sure main is always included
590 [ -z "$COMPONENTS" ]            && COMPONENTS="main"
591 [ "$_opt_contrib" ]             && COMPONENTS="$COMPONENTS contrib"
592
593 case "${RELEASE}" in
594   jessie|stretch|buster|bullseye)
595     [ "$_opt_non_free" ] && COMPONENTS="$COMPONENTS non-free"
596     ;;
597   *)
598     [ "$_opt_non_free" ] && COMPONENTS="$COMPONENTS non-free-firmware non-free"
599     ;;
600 esac
601
602 # command line option checks
603 if [ "$_opt_scripts_set" ] ; then
604   ewarn "Deprecation NOTE: --scripts option is deprecated, please switch to --post-scripts instead."
605   SCRIPTS='yes' # deprecated since grml-debootstrap >=0.71
606 fi
607
608 if [ "$_opt_grub" ] && [ "$_opt_vmfile" ] ; then
609   eerror "The --grub option is incompatible with --vmfile, please drop it from your command line."
610   eerror "The --grub option is unneeded as GRUB will be installed automatically (unless GRUB_INSTALL='no')."
611   bailout 1
612 fi
613
614 if [ "${_opt_sshcopyid}" ] && [ "${_opt_sshcopyauth}" ] ; then
615   eerror "The --sshcopyid option is incompatible with --sshcopyauth, please drop either of them from your command line."
616   bailout 1
617 fi
618
619 if [ -n "$ISO" ] && [[ "$DEBOOTSTRAP" =~ mmdebstrap$ ]] ; then
620   eerror "The ISO option is incompatible with usage of mmdebstrap for bootstrapping."
621   eerror "Either drop the --iso ... option or use plain debootstrap instead."
622   bailout 1
623 fi
624
625 if [ "$DEBUG" = "true" ] ; then
626   set -x
627 fi
628
629 [ "$_opt_help" ] && {
630   usage
631   exit 0
632 }
633
634 [ "$_opt_version" ] && {
635   einfo "$PN - version $VERSION"
636   einfo "Report bugs via https://github.com/grml/grml-debootstrap/ or https://grml.org/bugs/"
637   exit 0
638 }
639 # }}}
640
641 # check for root permissions {{{
642 if ! check4root ; then
643    echo "For usage instructions please execute '$PN --help'."
644    bailout 1
645 fi
646 # }}}
647
648 # make sure we have what we need {{{
649 check4progs "${DEBOOTSTRAP}" || bailout 1
650
651 if [ -n "$VIRTUAL" ] ; then
652   check4progs kpartx parted qemu-img || bailout 1
653 fi
654 # }}}
655
656 # source specified configuration file {{{
657 if [ -n "$CONFIGFILE" ] ; then
658   einfo "Reading specified config file $CONFIGFILE."
659   # shellcheck disable=SC1091 source=config
660   if ! . "$CONFIGFILE" ; then
661     eerror "Error reading config file $CONFIGFILE" ; bailout 1
662   fi
663 fi
664 # }}}
665
666 # backwards compatibility checks {{{
667 if [ -n "$GROOT" ] ; then
668    eerror "Error: you seem to have \$GROOT configured."
669    eerror "This variable is no longer supported, please visit the"
670    eerror "grml-debootstrap documentation for details."
671    bailout 1
672 fi
673
674 if echo "$GRUB" | grep -q '^hd' ; then
675    eerror "Error: this syntax for the grub configuration variable is no longer supported."
676    eerror "Please do not use hd... any longer but /dev/sdX instead."
677    bailout 1
678 fi
679 # }}}
680
681 # welcome screen {{{
682 welcome_dialog()
683 {
684    dialog --title "$PN" --yesno "Welcome to the interactive configuration of ${PN}.
685 Do you want to continue installing Debian using this frontend?" 0 0 || bailout 0
686 }
687 # }}}
688
689 # ask for target {{{
690 prompt_for_target()
691 {
692   AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
693                sed 's/*//' | \
694                grep -v 'Extended$' | \
695                gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}'; ls /dev/md[0-9]* 2>/dev/null || true);
696
697   if [ -z "$AVAILABLE_PARTITIONS" ] ; then
698      dialog --title "$PN" --trim \
699      --msgbox "Sorry, no partitions found. Please configure your
700      harddisks (see /proc/partitions) using a tool like fdisk,
701      cfdisk, gpart, gparted,..." 0 0
702      bailout 1
703   fi
704
705   PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
706                      fs="$(blkid -s TYPE -o value "$i" 2>/dev/null)"
707                      [ -n "$fs" ] || fs='[no_filesystem_yet]'
708                      echo "$i" "$fs"
709                      unset fs
710                    done)
711
712   # shellcheck disable=SC2086
713   TARGET=$(dialog --title "$PN" --single-quoted --stdout \
714          --menu "Please select the target partition:" 0 0 0 \
715          $PARTITION_LIST)
716   [ $? -eq 0 ] || bailout 1
717 }
718 # }}}
719
720 # ask for bootmanager {{{
721 prompt_for_bootmanager()
722 {
723   ADDITIONAL_PARAMS=""
724
725   if echo "$TARGET" | grep -q "/dev/md" ; then
726      MBRPART="all disks of Software RAID $TARGET"
727   else
728      # figure out whole disk device
729      found=
730      for device in /dev/disk/by-id/*
731      do
732         [ "$(readlink -f "$device")" = "${TARGET}" ] || continue
733         found=1
734         break
735      done
736      # shellcheck disable=SC2001
737      [ -n "$found" ] && MBRDISK=$(echo "${device}" | sed -e 's/-part[0-9][0-9]*$//')
738      if [ -e "$MBRDISK" ]; then
739         MBRDISK=$(readlink -f "$MBRDISK")
740      else
741         # fall back to old behaviour
742         # shellcheck disable=SC2001
743         MBRDISK=$(echo "${TARGET}" | sed -e 's/[0-9][0-9]*$//')
744      fi
745
746      MBRPART="MBR of $MBRDISK"
747   fi
748
749   for device in cciss/c0d0 sda hda; do
750     if [ "/dev/$device" != "${MBRDISK}" ]; then
751       grep -q $device /proc/partitions && \
752       ADDITIONAL_PARAMS="$ADDITIONAL_PARAMS:$device:install bootmanager grub into MBR of /dev/$device"
753     fi
754   done
755   ADDITIONAL_PARAMS=${ADDITIONAL_PARAMS#:}
756
757   OIFS="$IFS"; IFS=:
758
759   # shellcheck disable=SC2086
760   GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
761           --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
762             mbr       "install bootmanager into $MBRPART" \
763             nowhere   "do not install bootmanager at all" \
764           ${ADDITIONAL_PARAMS})
765   [ $? -eq 0 ] || bailout 3
766   IFS="$OIFS"
767
768   case "$GETMBR" in
769     mbr)
770       # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
771       if echo "$TARGET" | grep -q "/dev/md" ; then
772         GRUB="$TARGET"
773       else
774         GRUB="$MBRDISK"
775       fi
776       ;;
777     hda)
778       GRUB="/dev/hda"
779       ;;
780     sda)
781       GRUB="/dev/sda"
782       ;;
783     nowhere)
784       GRUB=''
785       ;;
786   esac
787 }
788 # }}}
789
790 # ask for Debian release {{{
791 prompt_for_release()
792 {
793   [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='bullseye'
794   RELEASE="$(dialog --stdout --title "${PN}" --default-item $DEFAULT_RELEASE --menu \
795             "Please enter the Debian release you would like to use for installation:" \
796             0 50 8 \
797             buster   Debian/10 \
798             bullseye Debian/11 \
799             bookworm Debian/12 \
800             sid      Debian/unstable)"
801   [ $? -eq 0 ] || bailout
802 }
803 # }}}
804
805 # ask for hostname {{{
806 prompt_for_hostname()
807 {
808   HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
809             "Please enter the hostname you would like to use for installation:" \
810             0 0 "$HOSTNAME")"
811   [ $? -eq 0 ] || bailout
812 }
813 # }}}
814
815 # ask for password {{{
816 prompt_for_password()
817 {
818   if [ "$_opt_nopassword" ] ; then
819     einfo "Skip asking for root password as requested."
820     return 0
821   fi
822
823   ROOTPW1='PW1'
824   ROOTPW2='PW2'
825   while [ "$ROOTPW1" != "$ROOTPW2" ]; do
826     ROOTPW1=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
827     "Please enter the password for the root account:" 10 60)
828     [ $? -eq 0 ] || bailout
829
830     ROOTPW2=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
831     "Please enter the password for the root account again for \
832     confirmation:" 10 60)
833     [ $? -eq 0 ] || bailout
834
835     if [ "$ROOTPW1" != "$ROOTPW2" ]; then
836       dialog --stdout --title "${PN}" --ok-label \
837         "Retry" --msgbox "Passwords do not match!" 10 60
838     fi
839   done
840   ROOTPASSWORD="$ROOTPW1"
841 }
842 # }}}
843
844 # ask for Debian mirror {{{
845 prompt_for_mirror()
846 {
847   [ -n "$ISO" ] && DEFAULT_MIRROR='local' || DEFAULT_MIRROR='net'
848
849   CHOOSE_MIRROR=$(dialog --stdout --title "$PN" --default-item $DEFAULT_MIRROR \
850           --menu "Where do you want to install from?" 0 0 0 \
851             net   "install via network (downloading from mirror)" \
852             local "install from local directory/mirror"
853           )
854   [ $? -eq 0 ] || bailout
855
856   if [ "$CHOOSE_MIRROR" = 'net' ] ; then
857      [ -n "$MIRROR" ] || MIRROR='http://deb.debian.org/debian'
858      MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
859                "Please enter Debian mirror you would like to use for installing packages." \
860                0 0 $MIRROR)"
861      [ $? -eq 0 ] || bailout
862   else # CHOOSE_MIRROR == local
863      [ -n "$ISO" ] || ISO='/mnt/mirror'
864      ISO="$(dialog --stdout --title "${PN}" --inputbox \
865                "Please enter directory name you would like to use for installing packages." \
866                0 0 $ISO)"
867      [ $? -eq 0 ] || bailout
868   fi
869 }
870 # }}}
871
872 # software raid setup {{{
873 config_swraid_setup()
874 {
875 TMPFILE=$(mktemp)
876
877 # Currently we support only raid1:
878 RAIDLEVEL='raid1'
879
880 MD_LIST=$(for i in $(seq 0 9) ; do
881             awk '{print $4}' /proc/partitions | grep -q "md$i" || \
882             echo "/dev/md$i /dev/md$i"
883           done)
884
885 # shellcheck disable=SC2086
886 TARGET=$(dialog --stdout --title "$PN" --default-item /dev/md0 \
887 --menu "Which device do you want to use for ${RAIDLEVEL}?
888
889 Notice: activated devices will not be listed for security reasons. Anyway, please make sure the selected device is not in use already!" 0 0 0 \
890 $MD_LIST)
891 [ $? -eq 0 ] || bailout 20
892
893 AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
894              sed 's/*//' | \
895              grep -v 'Extended$' | \
896              gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
897 [ -n "$AVAILABLE_PARTITIONS" ] || echo "Fatal error: no partitions available?"
898 PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
899                      echo "$i $(blkid -s TYPE -o value "$i" 2>/dev/null || echo '[no_filesystem_yet]') off"
900                  done)
901
902 # shellcheck disable=SC2086
903 dialog --title "$PN" --separate-output \
904        --checklist "Please select the partitions you would like to use for your $RAIDLEVEL on ${TARGET}:" 0 0 0 \
905        $PARTITION_LIST 2>"$TMPFILE"
906 [ $? -eq 0 ] || bailout
907 SELECTED_PARTITIONS="$(cat "$TMPFILE")"
908
909 NUM_PARTITIONS=0
910 while IFS= read -r i; do
911   NUM_PARTITIONS=$(( NUM_PARTITIONS + 1 ))
912 done < "$TMPFILE"
913
914 ERRORFILE=$(mktemp)
915 # shellcheck disable=SC2086
916 yes | mdadm --create "${TARGET}" --level="${RAIDLEVEL}" \
917       --raid-devices="${NUM_PARTITIONS}" ${SELECTED_PARTITIONS} >/dev/null 2>$ERRORFILE
918 RC=$?
919 if [ "$RC" = 0 ] ; then
920    dialog --title "$PN" --msgbox \
921    "Creating $TARGET was successful." 0 0
922    rm -f "$TMPFILE" "$ERRORFILE"
923 else
924    dialog --title "$PN" --msgbox \
925    "There was an error setting up $TARGET:
926
927 $(cat "$ERRORFILE")
928
929 Exiting." 0 0
930    rm -f "$TMPFILE" "$ERRORFILE"
931    bailout 1
932 fi
933
934 }
935
936 prompt_for_swraid()
937 {
938 if dialog --stdout --title "$PN" \
939           --defaultno --yesno "Do you want to configure Software RAID?
940
941 Please notice that only RAID level 1 is supported by ${PN} currently. Configuration will take place using mdadm." 0 0 ; then
942   config_swraid_setup
943 fi
944 }
945 # }}}
946
947 # user should recheck his configuration {{{
948 # support full automatic installation:
949 checkforrun() {
950    dialog --timeout 10 --title "$PN" \
951           --yesno "Do you want to stop at this stage?
952
953 Notice: you are running ${PN} in non-interactive mode.
954 ${PN} will install Debian ${RELEASE} on ${TARGET}.
955 Last chance to quit. Timeout of 10 seconds running....
956
957 Do you want to stop now?" 0 0 2>/dev/null
958 }
959 # }}}
960
961 # format efi partition {{{
962 format_efi_partition() {
963   if [ -z "$EFI" ] ; then
964     return 0
965   fi
966
967   if ! [ -b "$EFI" ] ; then
968     eerror "Specified efi argument [$EFI] not a valid block device."
969     bailout 1
970   fi
971
972   if fsck.vfat -bn "$EFI" >/dev/null; then
973     einfo "EFI partition $EFI seems to have a FAT filesystem, not modifying."
974   else
975     einfo "EFI partition $EFI doesn't seem to be formatted, creating filesystem."
976     mkfs.fat -F32 -n "EFI" "$EFI"
977     RC=$?
978     if [ ! $RC -eq 0 ] ; then
979       eerror "Error while creating filesystem on ${EFI}."
980       bailout 1
981     fi
982   fi
983 }
984 # }}}
985
986 # check for EFI support or try to enable it {{{
987 efi_support() {
988   local efivars_loaded=false
989   # this is for kernels versions before v3.10, which didn't provide efivarfs yet
990   if modprobe efivars &>/dev/null ; then
991     efivars_loaded=true
992   fi
993   # kernel versions v3.10 and newer usually provide efivarfs
994   if modprobe efivarfs &>/dev/null ; then
995     efivars_loaded=true
996   fi
997
998   if [ -d /sys/firmware/efi ] ; then
999     einfo "EFI support detected."
1000     return 0
1001   fi
1002
1003   if ! [ -d /sys/firmware/efi ] && [ "${efivars_loaded:-}" = "true" ] ; then
1004     einfo "EFI support detected, but system seems to be running in BIOS mode."
1005   fi
1006
1007   return 1
1008 }
1009 # }}}
1010
1011 # make sure the user is aware of the used configuration {{{
1012 checkconfiguration()
1013 {
1014
1015 if [ -z "$VIRTUAL" ] ; then
1016   if efi_support ; then
1017     if [ -z "$_opt_efi" ] ; then
1018       ewarn "EFI support detected but no --efi option given, please consider enabling it."
1019     fi
1020   else
1021     if [ -n "$_opt_efi" ] ; then
1022       eerror "EFI option used but no EFI support detected."
1023       bailout 1
1024     fi
1025   fi
1026 fi
1027
1028 if [ -n "$AUTOINSTALL" ] ; then
1029    if checkforrun ; then
1030       eerror "Exiting as requested"
1031       bailout 1
1032    fi
1033 elif [ -n "$INTERACTIVE" ] ; then
1034
1035    INFOTEXT="Please recheck configuration before execution:
1036    "
1037    [ -n "$TARGET" ]  && INFOTEXT="$INFOTEXT
1038    Target:          $TARGET"
1039    [ -n "$GRUB" ]    && INFOTEXT="$INFOTEXT
1040    Install grub:    $GRUB"
1041    [ -n "$EFI" ]    && INFOTEXT="$INFOTEXT
1042    Install efi:     $EFI"
1043    [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
1044    Using release:   $RELEASE"
1045    [ -n "$HOSTNAME" ] && INFOTEXT="$INFOTEXT
1046    Using hostname:  $HOSTNAME"
1047    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
1048    Using mirror:    $MIRROR"
1049    [ -n "$ISO" ]  && INFOTEXT="$INFOTEXT
1050    Using ISO:       $ISO"
1051    [ -n "$ARCH" ]  && INFOTEXT="$INFOTEXT
1052    Using arch:      $ARCH"
1053    [ -n "$CONFFILES" ] && INFOTEXT="$INFOTEXT
1054    Config files:    $CONFFILES"
1055
1056    INFOTEXT="$INFOTEXT
1057
1058 Is this ok for you? Notice: selecting 'No' will exit ${PN}."
1059
1060    dialog --title "$PN" --no-collapse \
1061           --yesno "$INFOTEXT" 0 0
1062    [ $? -eq 0 ] || bailout 0
1063
1064 else # if not running automatic installation display configuration and prompt for execution:
1065    einfo "$PN [${VERSION}] - Please recheck configuration before execution:"
1066    echo
1067    echo "   Target:          $TARGET"
1068
1069    # do not display if MNTPOINT is the default one
1070    case "$MNTPOINT" in /mnt/debootstrap*) ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
1071
1072    if [ -n "$VIRTUAL" ] && [ "$GRUB_INSTALL" = 'yes' ] ; then
1073       echo "   Install grub:    yes"
1074       [ -n "$VMEFI" ]   && echo "   Install efi:     yes"   || echo "   Install efi:     no"
1075    else
1076      [ -n "$GRUB" ]     && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
1077      [ -n "$EFI" ]      && echo "   Install efi:     $EFI"  || echo "   Install efi:     no"
1078    fi
1079
1080    [ -n "$RELEASE" ]   && echo "   Using release:   $RELEASE"
1081    [ -n "$HOSTNAME" ]  && echo "   Using hostname:  $HOSTNAME"
1082    [ -n "$MIRROR" ]    && echo "   Using mirror:    $MIRROR"
1083    [ -n "$ISO" ]       && echo "   Using ISO:       $ISO"
1084    [ -n "$ARCH" ]      && echo "   Using arch:      $ARCH"
1085    [ -n "$CONFFILES" ] && echo "   Config files:    $CONFFILES"
1086    if [ -n "$VIRTUAL" ] ; then
1087       echo "   Deploying as Virtual Machine."
1088       if [ -n "$VMSIZE" ] && [ -n "$VMFILE" ]; then
1089          echo "   Using Virtual Disk file with size of ${VMSIZE}."
1090       fi
1091    fi
1092
1093    if [ ! -t 0 ] && [ -z "$ROOTPASSWORD" ] && [ -z "$NOPASSWORD" ] ; then
1094       echo
1095       echo "   You do not have a TTY allocated, your password will be shown in"
1096       echo "   plaintext on the terminal! If you are using SSH, try its -t option!"
1097    fi
1098
1099    echo
1100    echo "   Important! Continuing will delete all data from ${TARGET}!"
1101
1102    if [ -n "$FORCE" ] ; then
1103      einfo "Skip user acknowledgement as requested via --force option."
1104    else
1105      echo
1106      einfon "Is this ok for you? [y/N] "
1107      read -r a
1108      if ! [ "$a" = 'y' ] || [ "$a" = 'Y' ] ; then
1109         eerror "Exiting as requested."
1110         bailout 1
1111      fi
1112    fi
1113 fi
1114 }
1115 # }}}
1116
1117 # interactive mode {{{
1118 interactive_mode()
1119 {
1120   check4progs dialog || bailout 1
1121
1122   welcome_dialog
1123
1124   prompt_for_release
1125
1126   prompt_for_swraid
1127
1128   prompt_for_target
1129
1130   prompt_for_bootmanager
1131
1132   prompt_for_hostname
1133
1134   prompt_for_password
1135
1136   prompt_for_mirror
1137 }
1138
1139 # run interactive mode if we didn't get the according configuration yet
1140 if [ -z "$TARGET" ] || [ -n "$INTERACTIVE" ] ; then
1141    # only target might be unset, so make sure the INTERACTIVE flag is set as well
1142    INTERACTIVE=1
1143    interactive_mode
1144 fi
1145 # }}}
1146
1147 # architecture setup {{{
1148 if [ -n "$ARCH" ] ; then
1149    ARCHCMD="--arch $ARCH"
1150    ARCHINFO=" (${ARCH})"
1151 else
1152    ARCH="$(dpkg --print-architecture)"
1153    ARCHCMD="--arch $ARCH"
1154    ARCHINFO=" (${ARCH})"
1155 fi
1156
1157 if [ -z "${ARCH:-}" ] ; then
1158   eerror 'Architecture neither set (environment variable ARCH), nor could be automatically identified (using dpkg).'
1159   eerror 'Consider setting the --arch ... option.'
1160   bailout 1
1161 fi
1162 # }}}
1163
1164 # It is not possible to build amd64 on i686. {{{
1165 CURRENT_ARCH="$(uname -m)"
1166 if [ "$CURRENT_ARCH" != "x86_64" ] ; then
1167    if [ "$ARCH" = "amd64" ] ; then
1168       eerror "It is not possible to build amd64 on $CURRENT_ARCH. Consider installing and booting the 'linux-image-amd64' kernel or using '--arch i386' instead."
1169       bailout 1
1170    fi
1171 fi
1172 # }}}
1173
1174 # Support for generic release codenames is unavailable. {{{
1175 if [ "$RELEASE" = "stable" ] || [ "$RELEASE" = "testing" ] ; then
1176    eerror "Generic release codenames (stable, testing) are unsupported. \
1177 Please use specific codenames such as bullseye or bookworm."
1178    bailout 1
1179 fi
1180 # }}}
1181
1182 checkconfiguration
1183
1184 # finally make sure at least $TARGET is set [the partition for the new system] {{{
1185 if [ -n "$TARGET" ] ; then
1186    SHORT_TARGET="${TARGET##*/}"
1187 else
1188    eerror "Please adjust $CONFFILES/config or..."
1189    eerror "... use the interactive version for configuration before running ${0}"
1190    bailout 1
1191 fi
1192 # }}}
1193
1194 # stages setup {{{
1195 if [ -z "$STAGES" ] ; then
1196    STAGES="/var/cache/grml-debootstrap/stages_${SHORT_TARGET}"
1197    [ -d "$STAGES" ] || mkdir -p "$STAGES"
1198 fi
1199
1200 if [ -r "$STAGES"/grml-debootstrap ] ; then
1201    if grep -q 'done' "${STAGES}/grml-debootstrap" ; then
1202       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
1203       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}"
1204    fi
1205 fi
1206 # }}}
1207
1208 # partition handling {{{
1209 PARTITION=''
1210 DIRECTORY=''
1211
1212 set_target_directory(){
1213     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
1214     DIRECTORY=1
1215     MNTPOINT="$TARGET"
1216     MKFS=''
1217     TUNE2FS=''
1218     FSCK=''
1219     # make sure we normalise the path to an absolute directory name so something like:
1220     #  mkdir -p foo/a bar/a; (cd foo; grml-debootstrap -t a)&; (cd bar; grml-debootstrap -t a)&; wait
1221     # works
1222     TARGET="$(readlink -f "$TARGET")"
1223 }
1224
1225 if [ -b "$TARGET" ] || [ -n "$VIRTUAL" ] ; then
1226     PARTITION=1
1227 else
1228     # $TARGET was not detected as block device, but we do not want to create target directory in /dev/
1229     if [[ $TARGET == "/dev/"* ]]; then
1230       eerror "Error: Will not create target directory $TARGET in /dev."
1231       eerror "  Please check the partition(s) of the blockdevice."
1232       bailout 1
1233     fi
1234     set_target_directory
1235 fi
1236 # }}}
1237
1238 # make sure we have the right syntax when using an iso image {{{
1239 if [ -n "$ISO" ] ; then
1240    case $ISO in
1241       file*) # do nothing
1242       ;;
1243       *)
1244       ISO=file:$ISO
1245       ;;
1246    esac
1247 fi
1248 ISODIR=${ISO##file:}
1249 ISODIR=${ISODIR%%/}
1250 # }}}
1251
1252 # Debian ISOs do not contain signed Release files {{{
1253 if [ -n "$ISO" ] ; then
1254     DEBOOTSTRAP_OPT="$DEBOOTSTRAP_OPT --no-check-gpg"
1255 fi
1256 # }}}
1257
1258 # create filesystem {{{
1259 mkfs() {
1260   if [ -n "$DIRECTORY" ] ; then
1261      einfo "Running grml-debootstrap on a directory, skipping mkfs stage."
1262      return 0
1263   fi
1264
1265   if grep -q "$TARGET" /proc/mounts ; then
1266     eerror "$TARGET already mounted, exiting to avoid possible damage. (Manually unmount $TARGET)"
1267     bailout 1
1268   fi
1269
1270   # mkfs.ext* might prompt with "/dev/sdX# contains a ext* file system
1271   # created on ... Proceed anyway? (y,n)" which we want to skip in force mode
1272   if [ -n "$MKFS" ] && [ -n "$FORCE" ] ; then
1273     case "$MKFS" in
1274       mkfs.ext*)
1275         einfo "Enabling force option (-F) for mkfs.ext* tool as requested via --force switch."
1276         MKFS_OPTS="$MKFS_OPTS -F"
1277         ;;
1278     esac
1279   fi
1280
1281   # starting with e2fsprogs 1.43~WIP.2015.05.18-1 mkfs.ext4 enables the metadata_csum feature
1282   # by default, which requires a recent version of tune2fs on the target system then,
1283   # so disable this feature for older Debian releases where it's known to be unsupported
1284   if [ -n "$MKFS" ] && [ "$MKFS" = "mkfs.ext4" ] ; then
1285     case "$RELEASE" in
1286       jessie)
1287         # assume a more recent version if we can't identify the version via dpkg-query
1288         local e2fsprogs_version
1289         e2fsprogs_version="$(dpkg-query --show --showformat='${Version}' e2fsprogs 2>/dev/null || echo 1.44)"
1290         if [ -n "$e2fsprogs_version" ] && dpkg --compare-versions "$e2fsprogs_version" ge '1.43~WIP.2015.05.18-1' ; then
1291           einfo "Disabling metadata_csum feature for $MKFS as $RELEASE doesn't support it."
1292           MKFS_OPTS="$MKFS_OPTS -O ^metadata_csum"
1293         fi
1294         ;;
1295     esac
1296   fi
1297
1298   # starting with e2fsprogs v1.47.0 mkfs.ext4 enables the metadata_csum_seed feature
1299   # by default, which requires Linux kernel >=4.4, e2fsprogs >=1.43, according GRUB etc.
1300   # Disable this feature for Debian releases older than bookworm
1301   if [ -n "$MKFS" ] && [ "$MKFS" = "mkfs.ext4" ] ; then
1302     case "$RELEASE" in
1303       jessie|stretch|buster|bullseye)
1304         local e2fsprogs_version
1305         # assume a more recent version if we can't identify the version via dpkg-query
1306         e2fsprogs_version="$(dpkg-query --show --showformat='${Version}' e2fsprogs 2>/dev/null || echo 1.47)"
1307         if [ -n "$e2fsprogs_version" ] && dpkg --compare-versions "$e2fsprogs_version" ge '1.43' ; then
1308           einfo "Disabling metadata_csum_seed feature for $MKFS as $RELEASE doesn't support it."
1309           MKFS_OPTS="$MKFS_OPTS -O ^metadata_csum_seed"
1310         fi
1311         ;;
1312     esac
1313   fi
1314
1315   if [ -n "$MKFS" ] ; then
1316
1317     if [ -n "${ARM_EFI_TARGET}" ] ; then
1318       einfo "Running mkfs.fat $MKFS_OPTS on $ARM_EFI_TARGET"
1319       mkfs.fat -n "EFI" "$ARM_EFI_TARGET"
1320       MKFS_OPTS="$MKFS_OPTS -L LINUX"
1321     fi
1322
1323     einfo "Running $MKFS $MKFS_OPTS on $TARGET"
1324     # shellcheck disable=SC2086
1325     "$MKFS" $MKFS_OPTS "$TARGET" ; RC=$?
1326
1327     if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1328       if ! echo "$MKFS" | grep -q "mkfs.ext" ; then
1329         eerror "Not changing disk uuid for $TARGET because $MKFS doesn't seem to match for ext{2,3,4} file system"
1330         bailout 1
1331       else
1332         einfo "Changing disk uuid for $TARGET to fixed (non-random) value $DISK_IDENTIFIER using tune2fs"
1333         tune2fs "$TARGET" -U "$DISK_IDENTIFIER" </dev/null
1334       fi
1335     fi
1336
1337     if [ -n "$VIRTUAL" ] && [ -n "$EFI_TARGET" ]; then
1338       einfo "Creating FAT filesystem on $EFI_TARGET"
1339       mkfs.fat -F32 -n "EFI" "$EFI_TARGET"
1340     fi
1341
1342     # make sure /dev/disk/by-uuid/... is up2date, otherwise grub
1343     # will fail to detect the uuid in the chroot
1344     if [ -n "$VIRTUAL" ] ; then
1345       einfo "Virtual environment doesn't require blockdev --rereadpt, skipping therefore"
1346     elif echo "$TARGET" | grep -q "/dev/md" ; then
1347       blockdev --rereadpt "${TARGET}"
1348     else
1349       # if we deploy to /dev/sdX# then let's see if /dev/sdX exists
1350       local main_device="${TARGET%%[0-9]*}"
1351       # sanity check to not try to e.g. access /dev/loop if we get /dev/loop0
1352       if [ -f "/sys/block/$(basename "${main_device}")/$(basename "${TARGET}")/dev" ] ; then
1353         blockdev --rereadpt "$main_device"
1354       else
1355         einfo "No underlying block device for $TARGET identified, skipping blockdev --rereadpt."
1356       fi
1357     fi
1358     # give the system 2 seconds, otherwise we might run into
1359     # race conditions :-/
1360     sleep 2
1361
1362     eend $RC
1363   fi
1364 }
1365 # }}}
1366
1367 # retrieve ID_FS_UUID {{{
1368 identify_target_uuid() {
1369   local device="$1"
1370
1371   if ! [ -b "$device" ] ; then
1372     return 1
1373   fi
1374
1375   eval "$(blkid -o udev "$1" 2>/dev/null)"
1376
1377   if [ -n "$ID_FS_UUID" ] ; then
1378     echo "$ID_FS_UUID"
1379   else
1380     return 1
1381   fi
1382 }
1383 # }}}
1384
1385 # identify TARGET_UUID {{{
1386 mountpoint_to_blockdevice() {
1387   TARGET_UUID=''
1388
1389   TARGET_UUID=$(identify_target_uuid "$TARGET" 2>/dev/null || true)
1390   if [ -n "$TARGET_UUID" ] ; then
1391     einfo "Identified UUID $TARGET_UUID for $TARGET"
1392     return 0
1393   fi
1394
1395   # $TARGET might be a mountpoint and not a blockdevice, search for according entry
1396   for file in /sys/block/*/*/dev ; do
1397     if grep -q "^$(mountpoint -d "${TARGET}")$" "$file" ; then
1398       local dev
1399       dev="${file%/dev}"
1400       dev="/dev/${dev##*/}"
1401       TARGET_UUID=$(identify_target_uuid "$dev" 2>/dev/null || true)
1402
1403       if [ -n "$TARGET_UUID" ] ; then
1404         einfo "Identified UUID $TARGET_UUID for $TARGET (via $file)"
1405         return 0
1406       fi
1407     fi
1408   done
1409 }
1410 # }}}
1411
1412 # modify filesystem settings {{{
1413 tunefs() {
1414   if [ -n "$TUNE2FS" ] && echo "$MKFS" | grep -q "mkfs.ext" ; then
1415      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
1416      $TUNE2FS "$TARGET" </dev/null
1417   fi
1418 }
1419 # }}}
1420
1421 # mount the new partition or if it's a directory do nothing at all {{{
1422 mount_target() {
1423   if [ -n "$DIRECTORY" ] ; then
1424      einfo "Running grml-debootstrap on a directory, nothing to mount."
1425   else
1426      if grep -q "$TARGET" /proc/mounts ; then
1427         ewarn "$TARGET already mounted, continuing anyway."
1428      else
1429        if ! [ -d "${MNTPOINT}" ] ; then
1430           [ -n "$VIRTUAL" ] || mkdir -p "${MNTPOINT}"
1431        fi
1432        einfo "Mounting $TARGET to $MNTPOINT"
1433        mkdir -p "$MNTPOINT"
1434        mount -o rw,suid,dev "$TARGET" "$MNTPOINT"
1435      fi
1436   fi
1437   if [ -n "$ISODIR" ] ; then
1438      einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
1439      mkdir -p "$MNTPOINT/$ISODIR"
1440      mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
1441   fi
1442 }
1443 # }}}
1444
1445 # prepare VM image for usage with debootstrap {{{
1446 prepare_vm() {
1447   if [ -z "$VIRTUAL" ] ; then
1448      return 0 # be quiet by intention
1449   fi
1450
1451   if [ -b "$TARGET" ] && [ -n "$VMFILE" ] ; then
1452      eerror "Error: specified virtual disk target ($TARGET) is an existing block device."
1453      bailout 1
1454   fi
1455   if [ ! -b "$TARGET" ] && [ -z "$VMFILE" ] ; then
1456      eerror "Error: specified virtual disk target ($TARGET) does not exist yet."
1457      bailout 1
1458   fi
1459
1460   # make sure loop module is present and a usable loop device exists
1461   modprobe -q loop
1462   if ! losetup -f >/dev/null 2>&1; then
1463     eerror "Error finding usable loop device"
1464     bailout 1
1465   fi
1466
1467   # if dm-mod isn't available then kpartx will fail with
1468   # "Is device-mapper driver missing from kernel? [...]"
1469   modprobe -q dm-mod
1470   if ! grep -q 'device-mapper' /proc/misc >/dev/null 2>&1 ; then
1471     eerror "Device-mapper support missing in kernel."
1472     bailout 1
1473   fi
1474
1475   ORIG_TARGET="$TARGET" # store for later reuse
1476
1477   if [ -n "$VMFILE" ]; then
1478     qemu-img create -f raw "${TARGET}" "${VMSIZE}"
1479   fi
1480   if [ -n "$VMEFI" ]; then
1481     parted -s "${TARGET}" 'mklabel gpt'
1482     parted -s "${TARGET}" 'mkpart ESP fat32 1MiB 101MiB'
1483     parted -s "${TARGET}" 'set 1 boot on'
1484     parted -s "${TARGET}" 'mkpart bios_grub 101MiB 102MiB'
1485     parted -s "${TARGET}" 'set 2 bios_grub on'
1486     parted -s "${TARGET}" 'mkpart primary ext4 102MiB 100%'
1487
1488   else
1489     # arm64 support largely only exists for GPT
1490     if [ "$ARCH" = 'arm64' ]; then
1491       einfo "Setting up GPT partitions for arm64"
1492       parted -s "${TARGET}" 'mklabel gpt'
1493       parted -s "${TARGET}" 'mkpart EFI fat32 1MiB 10MiB'
1494       parted -s "${TARGET}" 'set 1 boot on'
1495       parted -s "${TARGET}" 'mkpart LINUX ext4 10MiB 100%'
1496     else
1497       parted -s "${TARGET}" 'mklabel msdos'
1498       if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1499         einfo "Adjusting disk signature to a fixed (non-random) value"
1500         MBRTMPFILE=$(mktemp)
1501         dd if="${TARGET}" of="${MBRTMPFILE}" bs=512 count=1
1502         echo -en "\\x41\\x41\\x41\\x41" | dd of="${MBRTMPFILE}" conv=notrunc seek=440 bs=1
1503         dd if="${MBRTMPFILE}" of="${TARGET}" conv=notrunc
1504       fi
1505       parted -s "${TARGET}" 'mkpart primary ext4 4MiB 100%'
1506       parted -s "${TARGET}" 'set 1 boot on'
1507     fi
1508   fi
1509
1510   DEVINFO=$(kpartx -asv "$TARGET") # e.g. 'add map loop0p1 (254:5): 0 20477 linear 7:0 3' - will be multi-line for arm64
1511   if [ -z "${DEVINFO}" ] ; then
1512     eerror "Error setting up loopback device."
1513     bailout 1
1514   fi
1515
1516   # if we're building for arm64, we operate on the first line of $DEVINFO which is the EFI partition
1517   if [ "$ARCH" = 'arm64' ]; then
1518     LOOP_PART="${DEVINFO##add map }" # 'loop0p1 (254:5): 0 20477 linear 7:0 3'
1519     LOOP_PART="${LOOP_PART// */}"    # 'loop0p1'
1520     LOOP_DISK="${LOOP_PART%p*}"      # 'loop0'
1521     export ARM_EFI_TARGET="/dev/mapper/$LOOP_PART"
1522     DEVINFO=${DEVINFO##*$'\n'} # now set $DEVINFO to the last line which is the OS partition
1523   fi
1524
1525   # hopefully this always works as expected
1526   LOOP_PART="${DEVINFO##add map }" # 'loop0p1 (254:5): 0 20477 linear 7:0 3'
1527   LOOP_PART="${LOOP_PART// */}"    # 'loop0p1'
1528   if [ -n "$VMEFI" ]; then
1529     export EFI_TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop0p1'
1530     LOOP_PART="${LOOP_PART%p1}p3"
1531   fi
1532   LOOP_DISK="${LOOP_PART%p*}"      # 'loop0'
1533   export TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop0p1'
1534
1535   if [ -z "$TARGET" ] ; then
1536      eerror "Error: target could not be set to according /dev/mapper/* device."
1537      bailout 1
1538   fi
1539 }
1540 # }}}
1541
1542 # make VM image bootable {{{
1543 grub_install() {
1544   if [ -z "${VIRTUAL}" ] ; then
1545      return 0
1546   fi
1547   if [ "${GRUB_INSTALL}" != "yes" ] ; then
1548     einfo "Not installing GRUB as requested via \$GRUB_INSTALL=$GRUB_INSTALL"
1549     return 0
1550   fi
1551
1552   if ! mount "${TARGET}" "${MNTPOINT}" ; then
1553     eerror "Error: Mounting ${TARGET} failed, can not continue."
1554     bailout 1
1555   fi
1556
1557   if [ -n "${ARM_EFI_TARGET}" ]; then
1558     mkdir -p "${MNTPOINT}/boot/efi"
1559     if ! mount "${ARM_EFI_TARGET}" "${MNTPOINT}/boot/efi" ; then
1560       eerror "Error: Mounting ${ARM_EFI_TARGET} failed, can not continue."
1561       bailout 1
1562     fi
1563   fi
1564
1565   mount -t proc none "${MNTPOINT}"/proc
1566   mount -t sysfs none "${MNTPOINT}"/sys
1567   mount -t devtmpfs udev "${MNTPOINT}"/dev
1568   mount -t devpts devpts "${MNTPOINT}"/dev/pts
1569
1570   if [ -n "$ARM_EFI_TARGET" ]; then
1571     einfo "Installing Grub as bootloader into EFI."
1572
1573     chroot "${MNTPOINT}" grub-install --target=arm64-efi --efi-directory=/boot/efi --bootloader-id=debian --recheck --no-nvram --removable
1574   # Has chroot-script installed GRUB to MBR using grub-install (successfully), already?
1575   # chroot-script skips installation for unset ${GRUB}
1576   elif [[ -z "${GRUB}" ]] || ! dd if="${GRUB}" bs=512 count=1 2>/dev/null | cat -v | grep -Fq GRUB; then
1577     einfo "Installing Grub as bootloader."
1578
1579     if ! chroot "${MNTPOINT}" dpkg --list grub-pc 2>/dev/null | grep -q '^ii' ; then
1580       echo "Notice: grub-pc package not present yet, installing it therefore."
1581       # shellcheck disable=SC2086
1582       DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-pc
1583     fi
1584
1585     mkdir -p "${MNTPOINT}/boot/grub"
1586     if ! [ -d "${MNTPOINT}"/usr/lib/grub/i386-pc/ ] ; then
1587       eerror "Error: grub not installed inside Virtual Machine. Can not install bootloader."
1588       bailout 1
1589     fi
1590     cp -a "${MNTPOINT}"/usr/lib/grub/i386-pc "${MNTPOINT}/boot/grub/"
1591
1592     if [ -n "$VMEFI" ]; then
1593
1594       mkdir -p "${MNTPOINT}"/boot/efi
1595       mount -t vfat "${EFI_TARGET}" "${MNTPOINT}"/boot/efi
1596
1597       if ! chroot "${MNTPOINT}" dpkg --list shim-signed 2>/dev/null | grep -q '^ii' ; then
1598         echo "Notice: shim-signed package not present yet, installing it therefore."
1599         # shellcheck disable=SC2086
1600         DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS shim-signed
1601       fi
1602
1603       if [ "$(dpkg --print-architecture)" = "arm64" ]; then
1604         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-arm64-signed 2>/dev/null | grep -q '^ii' ; then
1605           echo "Notice: grub-efi-arm64-signed package not present yet, installing it therefore."
1606           # shellcheck disable=SC2086
1607           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-arm64-bin grub-efi-arm64-signed
1608         fi
1609         chroot "$MNTPOINT" grub-install --target=arm64-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1610       elif [ "$(dpkg --print-architecture)" = "i386" ]; then
1611         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-ia32-signed 2>/dev/null | grep -q '^ii' ; then
1612           echo "Notice: grub-efi-ia32-signed package not present yet, installing it therefore."
1613           # shellcheck disable=SC2086
1614           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-ia32-bin grub-efi-ia32-signed
1615         fi
1616         chroot "$MNTPOINT" grub-install --target=i386-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1617         chroot "$MNTPOINT" grub-install --target=i386-pc "/dev/$LOOP_DISK"
1618       else
1619         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-amd64-signed 2>/dev/null | grep -q '^ii' ; then
1620           echo "Notice: grub-efi-amd64-signed package not present yet, installing it therefore."
1621           # shellcheck disable=SC2086
1622           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-amd64-bin grub-efi-amd64-signed
1623         fi
1624         chroot "$MNTPOINT" grub-install --target=x86_64-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1625         chroot "$MNTPOINT" grub-install --target=i386-pc "/dev/$LOOP_DISK"
1626       fi
1627     else
1628       dd if="${MNTPOINT}/usr/lib/grub/i386-pc/boot.img" of="${ORIG_TARGET}" conv=notrunc bs=440 count=1
1629       case "${_opt_filesystem}" in
1630         f2fs)
1631           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos f2fs
1632           ;;
1633         xfs)
1634           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos xfs
1635           ;;
1636         # NOTE - we might need to distinguish between further filesystems
1637         *)
1638           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos ext2
1639           ;;
1640       esac
1641
1642       dd if="${MNTPOINT}/tmp/core.img" of="${ORIG_TARGET}" conv=notrunc seek=1
1643       rm -f "${MNTPOINT}/tmp/core.img"
1644     fi
1645   fi
1646
1647   # workaround for Debian bug #918590 with lvm + udev:
1648   # WARNING: Device /dev/... not initialized in udev database even after waiting 10000000 microseconds
1649   if [ -d /run/udev ] ; then
1650     einfo "Setting up bind-mount /run/udev"
1651     mkdir -p "${MNTPOINT}"/run/udev
1652     mount --bind /run/udev "${MNTPOINT}"/run/udev
1653   fi
1654
1655   if [ -n "${BOOT_APPEND}" ] ; then
1656     echo "Adding BOOT_APPEND configuration ['${BOOT_APPEND}'] to /etc/default/grub."
1657     sed -i "/GRUB_CMDLINE_LINUX_DEFAULT/ s#\"\$# ${BOOT_APPEND}\"#" "${MNTPOINT}/etc/default/grub"
1658   fi
1659
1660   einfo "Updating grub configuration file."
1661   chroot "${MNTPOINT}" update-grub
1662   chroot "${MNTPOINT}" sync
1663
1664   case "$RELEASE" in
1665     jessie)
1666       einfo "Applying workaround for GRUB font path bug in jessie (Debian #787685)."
1667       mkdir -p "${MNTPOINT}/boot/grub/fonts/"
1668       cp "${MNTPOINT}/usr/share/grub/unicode.pf2" "${MNTPOINT}/boot/grub/fonts/"
1669       ;;
1670   esac
1671
1672   if grep -q '^GRUB_DISABLE_LINUX_UUID=.*true' "${MNTPOINT}"/etc/default/grub 2>/dev/null ; then
1673     ewarn "GRUB_DISABLE_LINUX_UUID is set to true in /etc/default/grub, not adjusting root= in grub.cfg."
1674     ewarn "Please note that your system might NOT be able to properly boot."
1675   elif [ -z "$ARM_EFI_TARGET" ]; then
1676     einfo "Adjusting grub.cfg for successful boot sequence."
1677     sed -i "s;root=[^ ]\\+;root=UUID=$TARGET_UUID;" "${MNTPOINT}"/boot/grub/grub.cfg
1678   fi
1679
1680   # workaround for Debian bug #918590 with lvm + udev:
1681   # WARNING: Device /dev/... not initialized in udev database even after waiting 10000000 microseconds
1682   if mountpoint "${MNTPOINT}"/run/udev &>/dev/null ; then
1683     einfo "Unmounting bind-mount /run/udev"
1684     umount "${MNTPOINT}"/run/udev
1685   fi
1686
1687   umount "${MNTPOINT}"/proc
1688   umount "${MNTPOINT}"/sys
1689   umount "${MNTPOINT}"/dev/pts
1690   try_umount 3 "${MNTPOINT}"/dev
1691
1692   if [ -n "$VMEFI" ]; then
1693     umount "${MNTPOINT}"/boot/efi
1694   fi
1695
1696 }
1697 # }}}
1698
1699 # unmount VM image {{{
1700 umount_target() {
1701   if [ -z "${VIRTUAL}" ] ; then
1702      return 0
1703   fi
1704
1705   if [ -n "${ARM_EFI_TARGET}" ]; then
1706     umount "${MNTPOINT}/boot/efi"
1707   fi
1708
1709   umount "${MNTPOINT}"
1710   kpartx -d "${ORIG_TARGET}" >/dev/null
1711   # Workaround for a bug in kpartx which doesn't clean up properly,
1712   # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
1713   if dmsetup ls | grep -q "^${LOOP_PART} "; then
1714     kpartx -d "/dev/${LOOP_DISK}" >/dev/null
1715   fi
1716 }
1717 # }}}
1718
1719 # install main chroot {{{
1720 debootstrap_system() {
1721   if [ "$_opt_nodebootstrap" ]; then
1722      einfo "Skipping debootstrap as requested."
1723      return
1724   fi
1725
1726   if grep -q "$MNTPOINT" /proc/mounts || [ -n "$DIRECTORY" ] ; then
1727     :
1728   else
1729     eerror "Error: $MNTPOINT not mounted, can not continue."
1730     eend 1 ; exit 1
1731   fi
1732
1733   if [ -n "$ISO" ] ; then
1734     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${ISO}"
1735     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO"
1736     # shellcheck disable=SC2086
1737     "$DEBOOTSTRAP" $ARCHCMD $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$ISO"
1738     RC=$?
1739   else
1740     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}"
1741     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR"
1742     # shellcheck disable=SC2086
1743     "$DEBOOTSTRAP" $ARCHCMD $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$MIRROR"
1744     RC=$?
1745   fi
1746
1747   if [ $RC -ne 0 ] ; then
1748     if [ -r "$MNTPOINT/debootstrap/debootstrap.log" ] && \
1749       [ -s "$MNTPOINT/debootstrap/debootstrap.log" ] ; then
1750       einfo "Presenting last ten lines of debootstrap.log:"
1751       tail -10 "${MNTPOINT}"/debootstrap/debootstrap.log
1752       einfo "End of debootstrap.log"
1753     fi
1754   fi
1755
1756   eend $RC
1757 }
1758 # }}}
1759
1760 # prepare chroot via chroot-script {{{
1761 preparechroot() {
1762   einfo "Preparing chroot system"
1763
1764   # provide variables to chroot system
1765   CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
1766   touch "$CHROOT_VARIABLES"
1767   chmod 600 "$CHROOT_VARIABLES" # make sure nobody except root can read it
1768   echo "# Configuration of ${PN}"                                                                                   > "$CHROOT_VARIABLES"
1769   [ -n "$ARCH" ]                      && echo "ARCH='${ARCH//\'/\'\\\'\'}'"                                         >> "$CHROOT_VARIABLES"
1770   [ -n "$BACKPORTREPOS" ]             && echo "BACKPORTREPOS='${BACKPORTREPOS//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1771   [ -n "$BOOT_APPEND" ]               && echo "BOOT_APPEND='${BOOT_APPEND//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1772   [ -n "$CHROOT_SCRIPTS" ]            && echo "CHROOT_SCRIPTS='${CHROOT_SCRIPTS//\'/\'\\\'\'}'"                     >> "$CHROOT_VARIABLES"
1773   [ -n "$COMPONENTS" ]                && echo "COMPONENTS='${COMPONENTS//\'/\'\\\'\'}'"                             >> "$CHROOT_VARIABLES"
1774   [ -n "$CONFFILES" ]                 && echo "CONFFILES='${CONFFILES//\'/\'\\\'\'}'"                               >> "$CHROOT_VARIABLES"
1775   [ -n "$DEBCONF" ]                   && echo "DEBCONF='${DEBCONF//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1776   [ -n "$DEBIAN_FRONTEND" ]           && echo "DEBIAN_FRONTEND='${DEBIAN_FRONTEND//\'/\'\\\'\'}'"                   >> "$CHROOT_VARIABLES"
1777   [ -n "$DEBOOTSTRAP" ]               && echo "DEBOOTSTRAP='${DEBOOTSTRAP//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1778   [ -n "$DEFAULT_LOCALES" ]           && echo "DEFAULT_LOCALES='${DEFAULT_LOCALES//\'/\'\\\'\'}'"                   >> "$CHROOT_VARIABLES"
1779   [ -n "$DEFAULT_LANGUAGE" ]          && echo "DEFAULT_LANGUAGE='${DEFAULT_LANGUAGE//\'/\'\\\'\'}'"                 >> "$CHROOT_VARIABLES"
1780   [ -n "$EXTRAPACKAGES" ]             && echo "EXTRAPACKAGES='${EXTRAPACKAGES//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1781   [ -n "$EFI" ]                       && echo "EFI='${EFI//\'/\'\\\'\'}'"                                           >> "$CHROOT_VARIABLES"
1782   [ -n "$FALLBACK_MIRROR" ]           && echo "FALLBACK_MIRROR='${FALLBACK_MIRROR//\'/\'\\\'\'}'"                   >> "$CHROOT_VARIABLES"
1783   [ -n "$FILESYSTEM" ]                && echo "FILESYSTEM='${FILESYSTEM//\'/\'\\\'\'}'"                             >> "$CHROOT_VARIABLES"
1784   [ -n "$FORCE" ]                     && echo "FORCE='${FORCE//\'/\'\\\'\'}'"                                       >> "$CHROOT_VARIABLES"
1785   [ -n "$GRMLREPOS" ]                 && echo "GRMLREPOS='${GRMLREPOS//\'/\'\\\'\'}'"                               >> "$CHROOT_VARIABLES"
1786   [ -n "$GRUB" ]                      && echo "GRUB='${GRUB//\'/\'\\\'\'}'"                                         >> "$CHROOT_VARIABLES"
1787   [ -n "$HOSTNAME" ]                  && echo "HOSTNAME='${HOSTNAME//\'/\'\\\'\'}'"                                 >> "$CHROOT_VARIABLES"
1788   [ -n "$INITRD" ]                    && echo "INITRD='${INITRD//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1789   [ -n "$INITRD_GENERATOR" ]          && echo "INITRD_GENERATOR='${INITRD_GENERATOR//\'/\'\\\'\'}'"                 >> "$CHROOT_VARIABLES"
1790   [ -n "$INITRD_GENERATOR_OPTS" ]     && echo "INITRD_GENERATOR_OPTS='${INITRD_GENERATOR_OPTS//\'/\'\\\'\'}'"       >> "$CHROOT_VARIABLES"
1791   [ -n "$INSTALL_NOTES" ]             && echo "INSTALL_NOTES='${INSTALL_NOTES//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1792   [ -n "$ISODIR" ]                    && echo "ISODIR='${ISO//\'/\'\\\'\'}'"                                        >> "$CHROOT_VARIABLES"
1793   [ -n "$ISO" ]                       && echo "ISO='${ISO//\'/\'\\\'\'}'"                                           >> "$CHROOT_VARIABLES"
1794   [ -n "$KEEP_SRC_LIST" ]             && echo "KEEP_SRC_LIST='${KEEP_SRC_LIST//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1795   [ -n "$LOCALES" ]                   && echo "LOCALES='${LOCALES//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1796   [ -n "$MIRROR" ]                    && echo "MIRROR='${MIRROR//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1797   [ -n "$MKFS" ]                      && echo "MKFS='${MKFS//\'/\'\\\'\'}'"                                         >> "$CHROOT_VARIABLES"
1798   [ -n "$NOPASSWORD" ]                && echo "NOPASSWORD=\"true\""                                                 >> "$CHROOT_VARIABLES"
1799   [ -n "$NOKERNEL" ]                  && echo "NOKERNEL=\"true\""                                                   >> "$CHROOT_VARIABLES"
1800   [ -n "$PACKAGES" ]                  && echo "PACKAGES='${PACKAGES//\'/\'\\\'\'}'"                                 >> "$CHROOT_VARIABLES"
1801   [ -n "$POST_SCRIPTS" ]              && echo "POST_SCRIPTS='${POST_SCRIPTS//\'/\'\\\'\'}'"                         >> "$CHROOT_VARIABLES"
1802   [ -n "$PRE_SCRIPTS" ]               && echo "PRE_SCRIPTS='${PRE_SCRIPTS//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1803   [ -n "$RECONFIGURE" ]               && echo "RECONFIGURE='${RECONFIGURE//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1804   [ -n "$RELEASE" ]                   && echo "RELEASE='${RELEASE//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1805   [ -n "$RM_APTCACHE" ]               && echo "RM_APTCACHE='${RM_APTCACHE//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1806   [ -n "$ROOTPASSWORD" ]              && echo "ROOTPASSWORD='${ROOTPASSWORD//\'/\'\\\'\'}'"                         >> "$CHROOT_VARIABLES"
1807   [ -n "$SCRIPTS" ]                   && echo "SCRIPTS='${SCRIPTS//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1808   [ -n "$SECURE" ]                    && echo "SECURE='${SECURE//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1809   [ -n "$SELECTED_PARTITIONS" ]       && echo "SELECTED_PARTITIONS='${SELECTED_PARTITIONS//\'/\'\\\'\'}'"           >> "$CHROOT_VARIABLES"
1810   [ -n "$TARGET" ]                    && echo "TARGET='${TARGET//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1811   [ -n "$UPGRADE_SYSTEM" ]            && echo "UPGRADE_SYSTEM='${UPGRADE_SYSTEM//\'/\'\\\'\'}'"                     >> "$CHROOT_VARIABLES"
1812   [ -n "$TARGET_UUID" ]               && echo "TARGET_UUID='${TARGET_UUID//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1813   [ -n "$TIMEZONE" ]                  && echo "TIMEZONE='${TIMEZONE//\'/\'\\\'\'}'"                                 >> "$CHROOT_VARIABLES"
1814   [ -n "$TUNE2FS" ]                   && echo "TUNE2FS='${TUNE2FS//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1815   [ -n "$VMSIZE" ]                    && echo "VMSIZE='${VMSIZE//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1816
1817   cp $VERBOSE "${CONFFILES}"/chroot-script "${MNTPOINT}"/bin/chroot-script
1818   chmod 755 "${MNTPOINT}"/bin/chroot-script
1819   [ -d "$MNTPOINT"/etc/debootstrap/ ] || mkdir "$MNTPOINT"/etc/debootstrap/
1820
1821   # make sure we have our files for later use via chroot-script
1822   cp $VERBOSE "${CONFFILES}/config"           "${MNTPOINT}"/etc/debootstrap/
1823   # make sure we adjust the configuration variables accordingly:
1824   sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" "${MNTPOINT}"/etc/debootstrap/config
1825   sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    "${MNTPOINT}"/etc/debootstrap/config
1826   sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          "${MNTPOINT}"/etc/debootstrap/config
1827
1828   # install notes:
1829   if [ -n "$INSTALL_NOTES" ] ; then
1830      [ -r "$INSTALL_NOTES" ] && cp "$INSTALL_NOTES" "${MNTPOINT}"/etc/debootstrap/
1831   fi
1832
1833   # package selection:
1834   if [ "$PACKAGES" = 'yes' ] ; then
1835     PACKAGES_FILE="packages"
1836
1837     if [ "$ARCH" = 'arm64' ]; then
1838       PACKAGES_FILE="packages-arm64"
1839     fi
1840
1841     cp $VERBOSE "${_opt_packages:-$CONFFILES/$PACKAGES_FILE}" \
1842       "${MNTPOINT}/etc/debootstrap/${PACKAGES_FILE}"
1843   fi
1844
1845   # debconf preseeding:
1846   _opt_debconf=${_opt_debconf:-$CONFFILES/debconf-selections}
1847   [ -f "${_opt_debconf}" ] && [ "$DEBCONF" = 'yes' ] && \
1848     cp $VERBOSE "${_opt_debconf}" "${MNTPOINT}"/etc/debootstrap/debconf-selections
1849
1850   # copy scripts that should be executed inside the chroot:
1851   _opt_chroot_scripts=${_opt_chroot_scripts:-$CONFFILES/chroot-scripts/}
1852   [ -d "$_opt_chroot_scripts" ] && [ "$CHROOT_SCRIPTS" = 'yes' ] && {
1853     mkdir -p "${MNTPOINT}"/etc/debootstrap/chroot-scripts
1854     cp -a $VERBOSE "${_opt_chroot_scripts}"/* "${MNTPOINT}"/etc/debootstrap/chroot-scripts/
1855   }
1856
1857   # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
1858   cp $VERBOSE "${CHROOT_VARIABLES}" "${MNTPOINT}"/etc/debootstrap/variables
1859
1860   cp $VERBOSE -a -L "${CONFFILES}"/extrapackages/ "${MNTPOINT}"/etc/debootstrap/
1861
1862   # make sure we can access network [relevant for cdebootstrap/mmdebstrap]
1863   [ -f "${MNTPOINT}"/etc/resolv.conf ] || cp $VERBOSE /etc/resolv.conf "${MNTPOINT}"/etc/resolv.conf
1864
1865   # setup default locales
1866   [ -n "$LOCALES" ] && cp $VERBOSE "${CONFFILES}"/locale.gen "${MNTPOINT}"/etc/locale.gen
1867
1868   # copy any existing files to chroot
1869   [ -d "${CONFFILES}"/bin   ] && cp $VERBOSE -a -L "${CONFFILES}"/bin/*   "${MNTPOINT}"/bin/
1870   [ -d "${CONFFILES}"/boot  ] && cp $VERBOSE -a -L "${CONFFILES}"/boot/*  "${MNTPOINT}"/boot/
1871   [ -d "${CONFFILES}"/etc   ] && cp $VERBOSE -a -L "${CONFFILES}"/etc/*   "${MNTPOINT}"/etc/
1872   [ -d "${CONFFILES}"/sbin  ] && cp $VERBOSE -a -L "${CONFFILES}"/sbin/*  "${MNTPOINT}"/sbin/
1873   [ -d "${CONFFILES}"/share ] && cp $VERBOSE -a -L "${CONFFILES}"/share/* "${MNTPOINT}"/share/
1874   [ -d "${CONFFILES}"/usr   ] && cp $VERBOSE -a -L "${CONFFILES}"/usr/*   "${MNTPOINT}"/usr/
1875   [ -d "${CONFFILES}"/var   ] && cp $VERBOSE -a -L "${CONFFILES}"/var/*   "${MNTPOINT}"/var/
1876
1877   # network setup
1878   DEFAULT_INTERFACES="# /etc/network/interfaces - generated by grml-debootstrap
1879
1880 # Include files from /etc/network/interfaces.d when using
1881 # ifupdown v0.7.44 or newer:
1882 #source-directory /etc/network/interfaces.d
1883
1884 auto lo
1885 iface lo inet loopback
1886
1887 allow-hotplug eth0
1888 iface eth0 inet dhcp
1889 "
1890
1891   # add dhcp setting for Predictable Network Interface Names
1892   if [ -x /bin/udevadm ]; then
1893     tmpfile=$(mktemp)
1894     for interface in /sys/class/net/*; do
1895       udevadm info --query=all --path="${interface}" > "${tmpfile}"
1896       # skip virtual devices, like bridges, vboxnet,...
1897       if grep -q 'P: /devices/virtual/net/' "${tmpfile}" ; then
1898         continue
1899       fi
1900
1901       # iterate over possible naming policies by precedence (see udev/net/link-config.c),
1902       # use and stop on first match to have same behavior as udev's link_config_apply()
1903       for property in ID_NET_NAME_FROM_DATABASE ID_NET_NAME_ONBOARD ID_NET_NAME_SLOT ID_NET_NAME_PATH ID_NET_NAME_MAC ; do
1904         if grep -q "${property}" "${tmpfile}" ; then
1905           interface=$(grep "${property}" "${tmpfile}" | sed -n -e "s/E: ${property}=\([^\$*]\)/\1/p")
1906           DEFAULT_INTERFACES="${DEFAULT_INTERFACES}
1907 allow-hotplug ${interface}
1908 iface ${interface} inet dhcp
1909 "
1910           break
1911         fi
1912       done
1913     done
1914     rm -f "${tmpfile}"
1915   fi
1916
1917   if [ -n "$NOINTERFACES" ] ; then
1918     einfo "Not installing /etc/network/interfaces as requested via --nointerfaces option"
1919   elif [ -n "$USE_DEFAULT_INTERFACES" ] ; then
1920     einfo "Installing default /etc/network/interfaces as requested via --defaultinterfaces options."
1921     mkdir -p "${MNTPOINT}/etc/network"
1922     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1923   elif [ -n "$VIRTUAL" ] ; then
1924     einfo "Setting up Virtual Machine, installing default /etc/network/interfaces"
1925     mkdir -p "${MNTPOINT}/etc/network"
1926     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1927   elif [ -r /etc/network/interfaces ] ; then
1928     einfo "Copying /etc/network/interfaces from host to target system"
1929     mkdir -p "${MNTPOINT}/etc/network"
1930     cp $VERBOSE /etc/network/interfaces "${MNTPOINT}/etc/network/interfaces"
1931   else
1932     ewarn "Couldn't read /etc/network/interfaces, installing default /etc/network/interfaces"
1933     mkdir -p "${MNTPOINT}/etc/network"
1934     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1935   fi
1936
1937   # install config file providing some example entries
1938   if [ -r /etc/network/interfaces.examples ] && [ ! -r "$MNTPOINT/etc/network/interfaces.examples" ] ; then
1939     mkdir -p "${MNTPOINT}/etc/network"
1940     cp /etc/network/interfaces.examples "$MNTPOINT/etc/network/interfaces.examples"
1941   fi
1942
1943   if [ -n "${SSHCOPYID}" ] ; then
1944     AUTHORIZED_KEYS_SOURCE=${AUTHORIZED_KEYS_SOURCE:-$HOME/.ssh/authorized_keys}
1945     AUTHORIZED_KEYS_TARGET=${AUTHORIZED_KEYS_TARGET:-$MNTPOINT/root/.ssh/}
1946     if ssh-add -L >/dev/null 2>&1 ; then
1947       einfo "Use locally available public keys to authorise root login on the target system as requested via --sshcopyid option."
1948       mkdir -p "${MNTPOINT}"/root/.ssh
1949       chmod 0700 "${MNTPOINT}"/root/.ssh
1950       if ! ssh-add -L >> "${MNTPOINT}"/root/.ssh/authorized_keys ; then
1951         eerror "Error: executing 'ssh-add -L' failed."
1952         bailout 1
1953       fi
1954     elif [ -f "$AUTHORIZED_KEYS_SOURCE" ]; then
1955       einfo "copying '$AUTHORIZED_KEYS_SOURCE' to '$AUTHORIZED_KEYS_TARGET' as requested via --sshcopyid option."
1956       mkdir -p "$AUTHORIZED_KEYS_TARGET"
1957       chmod 0700 "$AUTHORIZED_KEYS_TARGET"
1958       if ! cp "$AUTHORIZED_KEYS_SOURCE" "$AUTHORIZED_KEYS_TARGET" ; then
1959         eerror "Error: copying '$AUTHORIZED_KEYS_SOURCE' to '$AUTHORIZED_KEYS_TARGET' failed"
1960         bailout 1
1961       fi
1962     else
1963       eerror "Error: Could not open a connection to your authentication agent or the agent has no identities."
1964       bailout 1
1965     fi
1966   fi
1967
1968   if [ -n "${SSHCOPYAUTH}" ] ; then
1969     AUTHORIZED_KEYS_SOURCE=${AUTHORIZED_KEYS_SOURCE:-${HOME}/.ssh/authorized_keys}
1970
1971     if ! [ -f "${AUTHORIZED_KEYS_SOURCE}" ]; then
1972       eerror "Error: could not read '${AUTHORIZED_KEYS_SOURCE}' for setting up SSH key login."
1973       bailout 1
1974     fi
1975
1976     AUTHORIZED_KEYS_TARGET="${MNTPOINT}/root/.ssh/"
1977     einfo "Copying '${AUTHORIZED_KEYS_SOURCE}' to '${AUTHORIZED_KEYS_TARGET}' as requested via --sshcopyauth option."
1978     mkdir -p "${AUTHORIZED_KEYS_TARGET}"
1979     chmod 0700 "${AUTHORIZED_KEYS_TARGET}"
1980     if ! cp "${AUTHORIZED_KEYS_SOURCE}" "${AUTHORIZED_KEYS_TARGET}" ; then
1981       eerror "Error: copying '${AUTHORIZED_KEYS_SOURCE}' to '${AUTHORIZED_KEYS_TARGET}' failed."
1982       bailout 1
1983     fi
1984   fi
1985
1986   if [ -d /run/udev ] ; then
1987     einfo "Setting up bind-mount /run/udev"
1988     mkdir -p "${MNTPOINT}"/run/udev
1989     mount --bind /run/udev "${MNTPOINT}"/run/udev
1990   fi
1991 }
1992 # }}}
1993
1994 # execute all scripts in /etc/debootstrap/pre-scripts/ {{{
1995 execute_pre_scripts() {
1996   # make sure hostname is set even before chroot-script get executed
1997   echo "$HOSTNAME" > "$MNTPOINT"/etc/hostname
1998
1999   # make sure we have $MNTPOINT available for our scripts
2000   export MNTPOINT
2001
2002   if [ -d "$_opt_pre_scripts" ] || [ "$PRE_SCRIPTS" = 'yes' ] ; then
2003     [ -d "$_opt_pre_scripts" ] && pre_scripts="$_opt_pre_scripts" || pre_scripts="${CONFFILES}/pre-scripts/"
2004     for script in "${pre_scripts}"/* ; do
2005       if [ -x "$script" ] ; then
2006         einfo "Executing pre-script $script"
2007         "$script"
2008       fi
2009     done
2010   fi
2011 }
2012 # }}}
2013
2014 # execute all scripts in /etc/debootstrap/post-scripts/ {{{
2015 execute_post_scripts() {
2016   # make sure we have $MNTPOINT and HOSTNAME available for our scripts
2017   export MNTPOINT
2018   export TARGET_HOSTNAME=$HOSTNAME
2019
2020   if [ -d "$_opt_scripts" ] || [ "$SCRIPTS" = 'yes' ] ; then
2021     # legacy support for /etc/debootstrap/scripts/
2022     [ -d "$_opt_scripts" ] && post_scripts="$_opt_scripts" || post_scripts="${CONFFILES}/scripts/"
2023     ewarn "Deprecation NOTE: --scripts/SCRIPTS are deprecated, please switch to --post-scripts/POST_SCRIPTS instead."
2024   elif [ -d "$_opt_post_scripts" ] || [ "$POST_SCRIPTS" = 'yes' ] ; then
2025     [ -d "$_opt_post_scripts" ] && post_scripts="$_opt_post_scripts" || post_scripts="${CONFFILES}/post-scripts/"
2026   fi
2027
2028   if [ -n "$post_scripts" ] ; then
2029     for script in "${post_scripts}"/* ; do
2030       if [ -x "$script" ] ; then
2031         einfo "Executing post-script $script"
2032         "$script"
2033       fi
2034     done
2035   fi
2036 }
2037 # }}}
2038
2039 # unmount mountpoint {{{
2040 try_umount() {
2041   local tries=$1
2042   local mountpoint="$2"
2043
2044   for (( try=1; try<=tries; try++ )); do
2045     if [[ ${try} -eq ${tries} ]]; then
2046       # Last time, show errors this time
2047       umount "${mountpoint}" && return 0
2048     else
2049       # Not last time, hide errors until fatal
2050       if umount "${mountpoint}" 2>/dev/null ; then
2051         return 0
2052       else
2053         sleep 1
2054       fi
2055     fi
2056   done
2057   return 1  # Tried enough
2058 }
2059 # }}}
2060
2061 # execute chroot-script {{{
2062 chrootscript() {
2063   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
2064     mount_target
2065   fi
2066
2067   if ! [ -x "$MNTPOINT/bin/chroot-script" ] ; then
2068     eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
2069     eend 1
2070   else
2071     einfo "Executing chroot-script now"
2072     mount -t devtmpfs udev "${MNTPOINT}"/dev
2073     mount -t devpts devpts "${MNTPOINT}"/dev/pts
2074     if [ "$DEBUG" = "true" ] ; then
2075       chroot "$MNTPOINT" /bin/bash -x /bin/chroot-script ; RC=$?
2076     else
2077       chroot "$MNTPOINT" /bin/chroot-script ; RC=$?
2078     fi
2079     try_umount 3 "$MNTPOINT"/dev/pts
2080     try_umount 3 "$MNTPOINT"/dev
2081     eend $RC
2082   fi
2083
2084   # finally get rid of chroot-script again, there's no good reason to
2085   # keep it on the installed system
2086   if grep -q GRML_CHROOT_SCRIPT_MARKER "${MNTPOINT}/bin/chroot-script" ; then
2087     einfo "Removing chroot-script again"
2088     rm -f "${MNTPOINT}/bin/chroot-script"
2089   else
2090     einfo "Keeping chroot-script as string GRML_CHROOT_SCRIPT_MARKER could not be found"
2091   fi
2092 }
2093 # }}}
2094
2095 # unmount $MNTPOINT {{{
2096 umount_chroot() {
2097
2098   # display installation notes:
2099   if [ -n "$INSTALL_NOTES" ] ; then
2100      [ -r "${MNTPOINT}/${INSTALL_NOTES}" ] && cat "${MNTPOINT}/${INSTALL_NOTES}"
2101   fi
2102
2103   if [ -n "$ISODIR" ] ; then
2104      if grep -q "$ISODIR" /proc/mounts ; then
2105         einfo "Unmount $MNTPOINT/$ISODIR"
2106         umount "$MNTPOINT/$ISODIR"
2107      fi
2108   fi
2109
2110   if grep -q "$MNTPOINT" /proc/mounts ; then
2111     if mountpoint "${MNTPOINT}"/run/udev &>/dev/null ; then
2112       einfo "Unmounting bind-mount /run/udev"
2113       umount "${MNTPOINT}"/run/udev
2114     fi
2115
2116      if [ -n "$PARTITION" ] ; then
2117         einfo "Unmount $MNTPOINT"
2118         umount "$MNTPOINT"
2119      fi
2120   fi
2121 }
2122 # }}}
2123
2124 # execute filesystem check {{{
2125 fscktool() {
2126  if [ -n "$VIRTUAL" ] ; then
2127    einfo "Skipping filesystem check because we deploy a virtual machine."
2128    return 0
2129  fi
2130
2131  if [ "$FSCK" = 'yes' ] ; then
2132    [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
2133    einfo "Checking filesystem on $TARGET using $FSCKTOOL"
2134    "$FSCKTOOL" "$TARGET"
2135  fi
2136 }
2137 # }}}
2138
2139 # get rid of grml-debootstrap config files {{{
2140 remove_configs() {
2141   if [ "$REMOVE_CONFIGS" != "yes" ] ; then
2142     return 0
2143   fi
2144
2145   if ! mountpoint "${MNTPOINT}" >/dev/null 2>&1 ; then
2146     ewarn "Target ${MNTPOINT} doesn't seem to be mounted, can't remove configuration files."
2147     return 0
2148   fi
2149
2150   einfo "Removing configuration files from installed system as requested via --remove-configs / REMOVE_CONFIGS."
2151   rm -rf "${MNTPOINT}"/etc/debootstrap/
2152 }
2153 # }}}
2154
2155 # now execute all the functions {{{
2156 for i in format_efi_partition prepare_vm mkfs tunefs \
2157          mount_target mountpoint_to_blockdevice debootstrap_system \
2158          preparechroot execute_pre_scripts chrootscript execute_post_scripts \
2159          remove_configs umount_chroot grub_install umount_target fscktool ; do
2160     if stage "${i}" ; then
2161       "$i"
2162       if [ $? -eq 0 ]; then
2163         stage "${i}" 'done' && rm -f "${STAGES}/${i}"
2164       else
2165         bailout 2 "$i"
2166       fi
2167     fi
2168 done
2169
2170 cleanup
2171 # }}}
2172
2173 # end dialog of autoinstallation {{{
2174 if [ -n "$AUTOINSTALL" ] ; then
2175    if dialog --title "${PN}" --pause "Finished execution of ${PN}.
2176 Automatically rebooting in 10 seconds.
2177
2178 Choose Cancel to skip rebooting." 10 60 10 ; then
2179      noeject noprompt reboot
2180   fi
2181 else
2182    einfo "Finished execution of ${PN}. Enjoy your Debian system."
2183 fi
2184 # }}}
2185
2186 ## END OF FILE #################################################################
2187 # vim: ai tw=100 expandtab foldmethod=marker shiftwidth=2